for brain in context.portal_catalog(
    portal_type='Purchase Demand',
    simulation_state='auto_planned'
):
  brain.activate().PurchaseDemand_cancelAutoPlannedPurchaseDemand()


if now_for_test is not None:
  now = now_for_test
else:
  now = DateTime().earliestTime()

search_dict = {
  'predicate.start_date_range_min':{'query':now,
                                    'range':'ngt'},
  'predicate.start_date_range_max':{'query':now,
                                    'range':'nlt'}
}


for brain in context.portal_catalog(
portal_type=('Purchase Supply Line', 'Purchase Supply Cell'),
default_ledger_uid=context.portal_categories.ledger.automated_ordering.getUid(),
validation_state='validated',
**search_dict
):

  brain.activate(
    after_method_id=['PurchaseDemand_cancelAutoPlannedPurchaseDeman',
                     'recursiveImmediateReindexObject',
                     'immediateReindexObject'],
    ).Path_processPurchaseSupplyPathForAutomatedOrdering(now)

context.activate(
  after_method_id=['Alarm_createDemandListFromSupplyPathListForAutomatedOrdering',
                   'PurchaseDemand_cancelAutoPlannedPurchaseDemand',
                   'Path_processPurchaseSupplyPathForAutomatedOrdering',
                   'PurchaseOrder_cancelAutomatedOrderingPlannedPurchaseOrder',
                   'Path_generateDemandDocumentIfNeeded',
                   'recursiveImmediateReindexObject',
                   'immediateReindexObject',],
).Alarm_processDemandListForAutomatedOrdering()
