from Products.ERP5Type.Document import newTempOrder

tested_base_category_list = []
category_list = []

if not source_section and delivery is not None:
  source_section = delivery.getProperty('source_section')
if source_section:
  tested_base_category_list.append('source_section')
  category_list.append('source_section/%s' % source_section)

if not source and delivery is not None:
  source = delivery.getProperty('source')
if source:
  tested_base_category_list.append('source')
  category_list.append('source/%s' % source)

if not destination_section and delivery is not None:
  destination_section = delivery.getProperty('destination_section')
if destination_section:
  tested_base_category_list.append('destination_section')
  category_list.append('destination_section/%s' % destination_section)

if not destination and delivery is not None:
  destination = delivery.getProperty('destination')
if destination:
  tested_base_category_list.append('destination')
  category_list.append('destination/%s' % destination)

if not (source_section and destination_section):
  return []

if not tested_base_category_list:
  return []

count = len(tested_base_category_list) + 1

# if no date is defined, use today's date to retrieve predicate that define start_date_range_min/max
if start_date is None and delivery is not None:
  start_date = delivery.getStartDate()
if start_date is None:
  start_date = DateTime()

predicate_context = newTempOrder(context.getPortalObject(), 'temporary_document')
predicate_context.edit(categories=category_list, start_date=start_date)

def getRank(trade_condition):
  rank = 0
  trade_condition_destination_section = trade_condition.getDestinationSection()
  if trade_condition_destination_section and trade_condition_destination_section == destination_section:
    rank += 100

  trade_condition_source_section = trade_condition.getSourceSection()
  if trade_condition_source_section and trade_condition_source_section == source_section:
    rank += 100

  if destination:
    trade_condition_destination = trade_condition.getDestination()
    if trade_condition_destination and trade_condition_destination == destination:
      rank += 10

  if source:
    trade_condition_source = trade_condition.getSource()
    if trade_condition_source and trade_condition_source == source:
      rank += 10

  rank += len(trade_condition.getSpecialiseList())

  effective_date = trade_condition.getEffectiveDate()
  if effective_date is not None:
    point = 40 - (start_date - effective_date)/10.0
    if point > 0:
      rank += point
  return rank

temporary_result = []

for trade_condition in context.portal_domains.DomainTool_searchValidatedPredicateList(
  predicate_context,
  portal_type=trade_condition_portal_type,
  tested_base_category_list=tested_base_category_list):
  rank = getRank(trade_condition)
  temporary_result.append((rank, trade_condition))

temporary_result.sort()
temporary_result.reverse()
return [item[1] for item in temporary_result]
