from Products.ERP5Type.Document import newTempMovement
from Products.DCWorkflow.DCWorkflow import ValidationFailed
from Products.CMFCore.WorkflowCore import WorkflowException

ledger_automated_ordering_relative_url = context.portal_categories.ledger.automated_ordering.getCategoryRelativeUrl()

movement_list = []

supply_path_value = context.getSpecialiseValue()

if context.getSimulationState() == 'auto_planned':

  context.serializeSimulationState()

  try:
    order_dict_list = context.Base_getOrderDictListFromDemandForAutomatedOrdering()
  except Exception, e:
    context.fail(comment=e)
    return

  for dict_ in order_dict_list:
    resource_value = dict_['resource_value']
    movement = newTempMovement(context, 'temp_movement')
    movement.edit(
      source_section=supply_path_value.getSourceSection(),
      source=supply_path_value.getSource(),
      destination_section=supply_path_value.getDestinationSection(),
      destination=supply_path_value.getDestination(),
      price_currency=supply_path_value.getPriceCurrency(),
      resource=resource_value.getRelativeUrl(),
      variation_category_list=supply_path_value.getVariationCategoryList(),
      quantity_unit=dict_['quantity_unit_value'].getRelativeUrl(),
      quantity=dict_['quantity'],
      ledger=ledger_automated_ordering_relative_url,
      start_date=dict_['start_date'],
      stop_date=dict_['stop_date'],
      order_number=dict_['order_number'],#used for grouping only.
      causality_value=context
      )

    movement_list.append(movement)

  if movement_list:
    built_document_list = context.portal_orders.automated_ordering_purchase_order_builder.build(movement_list=movement_list)
    if 'cancelled' in [built_document.getSimulationState() for built_document in built_document_list]:
      for built_document in built_document_list:
        if built_document.getSimulationState() != 'cancelled':
          build_document.cancel()
      context.fail()
    else:
      context.confirm()
    return
  else:
    context.cancel()
    return
